% Aplikácia Fourier.transformácie na vyhľadanie harm.zložiek signálu s rušením
% Definovanie signálu v r.11 - súčet jednotl.HZ s rôznou amplitúdou, príp. fázou
% Pôvodný algoritmus: The MathWorks, Inc., 2012 (v MATLABe pozri help pre fft)
clc, clear
Fs = 1000;     % vzorkovacia frekvencia[Hz]                   
T = 1/Fs;      % perióda vzorkovania       
L = 1000;      % dlžka trvania signálu [ms]
t = (0:L-1)*T; % vektor času

% Vytvorenie a kreslenie signálu (tu súčet sinus: 50 Hz s ampl.=0.7 + 120 Hz s ampl. 1
S = 0.857*sin(2*pi*60*t) + sin(2*pi*220*t);  % S - výsledný signál (S=súčet) 
figure(1), plot (t,S), xlabel('\rightarrow t [s]'), ylabel('S')

% Rušenie signálu signálom bieleho šumu s nulovou strednou hodnotou
X = S + 10*randn(size(t)); % v tomto signáli zanikajú frekvenčné zložky
figure(2), plot(1000*t(1:50),X(1:50)),grid on 
    title(['Signál rušený bielym šumom s nulovou strednou hodnotou'])
    xlabel('\rightarrow t [ms]'), ylabel('\rightarrow X(t)')

Y = fft(X); % výpočet fft rušeného signálu; výsledok dáva komplexnú funkciu 
% Výpočet objstraného spektra P2 a z neho jednostranné spektrum P1 
%  pre párnu dĺžku signálu L.
P2 = abs(Y/L);  
P1 = P2(1:L/2+1);
P1(2:end-1) = 2*P1(2:end-1);
% Definovanie frekv.rozsahu a vykreslenie jednostranného ampl. spektra p1. 
% Vo všeobecnosti dhšie trvanie signálu dáva presnejšiu aproximáciu
f = Fs*(0:(L/2))/L;
% plot(f,P1), grid on, title('Single-Sided Amplitude Spectrum of X(t)')
    xlabel('\rightarrow f [Hz]'), ylabel('\rightarrow |P1(f)|')

% Výpočet a zobrazenie fft signálu
Y = fft(S);
P2 = abs(Y/L);
P1 = P2(1:L/2+1);
P1(2:end-1) = 2*P1(2:end-1);

figure(3)
plot(f,P1), grid on, title('Jednostranné amplitúdové spektrum signálu S(t)')
    xlabel('\rightarrow f [Hz]'), ylabel('\rightarrow |P1(f)|')