% Analógové filtre II., III., IV. rádu Butherworth, Čebyšev, Bessel
% Butterworth (Bw) s^2+ 1,41s + 1        s^3 + 2s^2 + 2s + 1
% Čebyšev     (Cb) 1,41s^2 + 0,91s + 1   3,98s^3 + 2,38s^2 + 3,7s + 1
% Bessel      (Be) s^2 + 3s + 3          s^3 + 6s^2+ 15s + 15

clc, clear, format compact
w=1; w2=w^2; w3=w^3; w4=w^4; % frekvencia zlomu
% definície prenosových funkcií
num=1;
denFBw2=[1/w2   1.4/w 1];  denFBw3=[1/w3 2/w2   2/w   1];  denFBw4=[1/w4    2.6/w3 3.4/w2 2.6/w 1]; 
denFCb2=[1.4/w2 0.9/w 1];  denFCb3=[4/w3 2.4/w2 3.7/w 1];  denFCb4=[5.65/w4 3.3/w3 6.6/w2 2.3/w 1];
denFBe2=[1/w2   3/w   3];  denFBe3=[1/w3 6/w2   15/w  15]; denFBe4=[1/w4    10/w3  45/w2  105/w 105];
FBw2=tf(num,denFBw2); FBw3=tf(num,denFBw3);  FBw4=tf(num,denFBw4);  
FCb2=tf(num,denFCb2); FCb3=tf(num,denFCb3);  FCb4=tf(num,denFCb4);  
FBe2=tf( 3 ,denFBe2); FBe3=tf(15,denFBe3);   FBe4=tf(105,denFBe4);  

% kreslenie charakteristík
figure(2)
subplot(121), step(FBw2,FCb2,FBe2), grid on, legend ('Bw','Cb','Be')
              title ('Filtre II. rádu')
subplot(122), bode(FBw2,FCb2,FBe2), grid on, legend ('Bw','Cb','Be')

figure(3)
subplot(121), step(FBw3,FCb3,FBe3), grid on 
              legend ('Bw','Cb','Be'), title ('Filtre III. rádu')
subplot(122), bode(FBw3,FCb3,FBe3), grid on, legend ('Bw','Cb','Be')

figure(4)
subplot(121), step(FBw4,FCb4,FBe4), grid on
              legend ('Bw','Cb','Be'), title ('Filtre IV. rádu') 
subplot(122), bode(FBw4,FCb4,FBe4), grid on, legend ('Bw','Cb','Be')

figure(5)
subplot(111), pzmap(FBw4,FCb4,FBe4), legend ('Bw','Cb','Be')
              title ('Poloha pólov filtrov IV. rádu')
              ax=gca, axis(ax,'equal')  % definuje rovnaké delenie na osiach 
