% Syntéza a analýza neharmonického signálu - obdĺžnikový signál
% w=1 
clc, clear, format compact
syms t a b n
pocetHZ=20 % počet HZ pre analýzu i pre syntézu

% Výpočet Fourierových koeficientov
a0=1/pi*int(1,t,0,pi);
a0=double(a0); 
for n=1:pocetHZ
    a(n)=1/pi*int(cos(n*t),t,0,pi);
    b(n)=1/pi*int(sin(n*t),t,0,pi);
    fi(n)=180/pi*atan2(a(n),b(n));
end
a=double(a);
b=double(b);
A=sqrt(a.^2+b.^2);
fi=double(fi);

% Grafy - vyššie HZ
figure(1)
subplot(221)
   stem(a), grid on, title ("Kosinusové zložky a(n); n = 1-"+n)
   xlabel('\rightarrow n'), ylabel('\rightarrow a(n)')
subplot(223)
   stem(b), grid on, title ("Sinusové zložky b(n); n = 1-"+n)
   xlabel('\rightarrow n'), ylabel('\rightarrow b(n)')
subplot(222)
   stem(A), grid on, title ("Amplitúdy A(n); n = 1-"+n)
   xlabel('\rightarrow n'), ylabel('\rightarrow A(n)')
subplot(224)
   stem(fi), grid on, title ("Fázy fi(n); n = 1-"+n)
   xlabel('\rightarrow n'), ylabel('\rightarrow \phi(n)')

% Syntéza priebehu f(t)
figure(2)
t=0:pi/200:2*pi;  % časový interval 
ft=0;      % súčtová bunka
for n=1:pocetHZ
    ft=ft+a(n).*cos(n*t)+b(n).*sin(n*t);
end
ft=a0/2+ft; % pripočítanie js zložky
plot(t,ft,'LineWidth',1.5), grid on, title("Syntéza obdĺžnik. signálu z "+pocetHZ+" HZ")
   xlabel('\rightarrow \rightarrowt [rad/s]'), ylabel('\rightarrow f(t)')